﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=B4XOpenMap.zip

Sub Class_Globals
	Private Root As B4XView
	Private fxui As XUI
	Private fcvMap As cvMap
	Private fMap As TMap
	Private fDlg As B4XDialog
	Private fPrefDlg As PreferencesDialog
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("main")
	
	fPrefDlg.Initialize(Root,"Map",500,500)
	fDlg.Initialize(Root)
	'init fmap with lat/lng, direction, zoom level, options and some markers
	fMap=coMapUtilities.initMap(coMapUtilities.initLatLng(47,2),10,0,False,False,False,False,False,False,False,False,False,False, _
	                            CreateMap("London":coMapUtilities.initMarker(coMapUtilities.initLatLng(51.5073509,-0.1277583),fxui.Color_Green), _
			 					          "Dakar":coMapUtilities.initMarker(coMapUtilities.initLatLng(14.7645042,-17.3660286),fxui.Color_Red), _
	                                      "New York":coMapUtilities.initMarker(coMapUtilities.initLatLng(40.712784,-74.005941),fxui.Color_Magenta), _
	                                      "Tokyo":coMapUtilities.initMarker(coMapUtilities.initLatLng(35.709026,139.731992),fxui.Color_Yellow)), _
										  True,coMapUtilities.initGPS(coMapUtilities.initLatLng(0,0),0))
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub B4XPage_Appear
	#IF B4A
	If Not(Starter.fGPS.GPSEnabled) Then
		wait for (fxui.MsgboxAsync("Please, enable GPS","Information")) MsgBox_Result (R As Int)
		StartActivity(Starter.fGPS.LocationSettingsIntent)
	Else
		Starter.frp.CheckAndRequest(Starter.frp.PERMISSION_ACCESS_FINE_LOCATION)
		Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
		If Result Then
			Log("Start GPS")
			CallSubDelayed(Starter,"Start_GPS")
		End If
	End If
	#END IF
End Sub

Private Sub B4XPage_Disappear
	
End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	
End Sub

'Private Sub B4XPage_PermissionResult 
'	
'End Sub

private Sub fcvmap_ready
	'set values
	fcvMap.Map=fMap
	'draw the map
	fcvMap.draw
End Sub


Private Sub fcvMap_compassDirectionChanged(aDirection As Double)
	Log("compass changed: " & aDirection)
End Sub

Private Sub fcvMap_CenterLatLngChanged(aLatLng As TMapLatLng)
	Log("lat/Lng changed : " & aLatLng)
End Sub

Private Sub fcvMap_zoomLevelChanged(aZoomLevel As Int)
	Log("zoom level changed : " & aZoomLevel)
End Sub

Private Sub fcvMap_MenuClicked
	fPrefDlg.Clear
	fPrefDlg.LoadFromJson(File.ReadString(File.DirAssets,"menu.json"))
	fPrefDlg.Title="goto Lat/Lng"
	Dim d As Map=CreateMap("offlineMode":fcvMap.OfflineMode,"showGrid":fcvMap.ShowGrid, _
	                       "showCenter":fcvMap.ShowCenter,"showLandmark":fcvMap.ShowLandmark, _
						   "showCenterLatLng":fcvMap.ShowCenterLatLng,"showZoom":fcvMap.ShowZoom, _
						   "showScale":fcvMap.ShowScale,"showCompass":fcvMap.ShowCompass, _
						   "showMarkers":fcvMap.ShowMarkers,"showGPS":fcvMap.ShowGPS)
	wait for (fPrefDlg.ShowDialog(d,"OK","CANCEL")) complete (result As Int)
	If result=fxui.DialogResponse_Positive Then
		fcvMap.OfflineMode=d.Get("offlineMode")
		fcvMap.ShowGrid=d.Get("showGrid")
		fcvMap.ShowCenter=d.Get("showCenter")
		fcvMap.ShowLandmark=d.Get("showLandmark")
		fcvMap.ShowCenterLatLng=d.Get("showCenterLatLng")
		fcvMap.ShowZoom=d.Get("showZoom")
		fcvMap.ShowScale=d.Get("showScale")
		fcvMap.ShowCompass=d.Get("showCompass")
		fcvMap.ShowMarkers=d.Get("showMarkers")
		fcvMap.ShowGPS=d.Get("showGPS")
	End If
End Sub

Private Sub fcvMap_gpsClicked(agps As TMapGPS)
	fcvMap.CenterLatLng=agps.fLatLng
	fcvMap.draw
End Sub

Private Sub fcvMap_compassClicked(adegres As Double)
	fcvMap.CompassDirection=0
End Sub

Private Sub fcvMap_ScaleClicked(aScale As Double)
	Log("128px = 	" & (aScale/2) & " meters")
End Sub

Private Sub fcvMap_CenterlatlngClicked(alatLng As TMapLatLng)
	fPrefDlg.Clear
	fPrefDlg.LoadFromJson(File.ReadString(File.DirAssets,"latlng.json"))
	fPrefDlg.Title="goto Lat/Lng"
	Dim d As Map=CreateMap("lat":alatLng.fLat,"lng":alatLng.fLng)
	wait for (fPrefDlg.ShowDialog(d,"OK","CANCEL")) complete (result As Int)
	If result=fxui.DialogResponse_Positive Then
		fcvMap.CenterLatLng=coMapUtilities.initLatLng(d.Get("lat"),d.Get("lng"))
		fcvMap.draw
	End If
End Sub

private Sub fcvmap_markerClicked(aKey As String)
	Dim sf As Object = fxui.Msgbox2Async("Remove this marker", aKey, "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = fxui.DialogResponse_Positive Then
		fcvMap.removeMarker(aKey)
	End If
End Sub

private Sub fcvmap_mapClicked(aLatLng As TMapLatLng)
	Dim sf As Object = fxui.Msgbox2Async("What do you want to do ?", "Question", "Add Marker", "Cancel", "Search",Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	Select Case Result
		Case  fxui.DialogResponse_Positive
			AddMarker(aLatLng)
		Case fxui.DialogResponse_Negative
			search
	End Select
End Sub

private Sub search
	Dim input As B4XInputTemplate
	input.Initialize
	input.lblTitle.Text = "Search address"
	Wait For (fDlg.ShowTemplate(input, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = fxui.DialogResponse_Positive Then
		SearchGeocoding(input.Text)
	End If
End Sub

private Sub SearchGeocoding(aquery As String)
	Dim su As StringUtils
	Dim q As String=su.EncodeUrl(aquery,"UTF8")
	Dim s As String=$"https://nominatim.openstreetmap.org/?addressdetails=1&q=${q}&format=json&limit=1"$
	Dim j As HttpJob
	Try
		j.Initialize("", Me)
		j.Download(s)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Try
				parseGeocoding(j.GetString)
			Catch
				Log(LastException.Message)
			End Try
		End If
	Catch
		Log(LastException.Message)
	End Try
	If j.IsInitialized Then
		j.Release
	End If
End Sub

private Sub parseGeocoding(ajson As String)
	Dim jp As JSONParser
	jp.Initialize(ajson)
	Dim l As List=jp.NextArray
	If l.Size>0 Then
		Dim m As Map=l.Get(0)
		Dim ll As TMapLatLng=coMapUtilities.initLatLng(m.Get("lat"),m.Get("lon"))
		fcvMap.addMarker(m.Get("display_name"),coMapUtilities.initMarker(ll,fxui.Color_Magenta))
		fcvMap.CenterLatLng=ll
		fcvMap.draw
	Else
		wait for (fxui.MsgboxAsync("not found","Error")) MsgBox_Result (R As Int)
	End If
End Sub

private Sub AddMarker(aLatLng As TMapLatLng)
	fPrefDlg.Clear
	fPrefDlg.LoadFromJson(File.ReadString(File.DirAssets,"addmarker.json"))
	fPrefDlg.Title="New marker"
	Dim d As Map=CreateMap("name":"New marker","color":fxui.Color_Black)
	wait for (fPrefDlg.ShowDialog(d,"OK","CANCEL")) complete (Result As Int)
	If Result=fxui.DialogResponse_Positive Then
		fcvMap.addMarker(d.Get("name"),coMapUtilities.initMarker(aLatLng,d.Get("color")))
	End If
End Sub

